pico-8 cartridge // http://www.pico-8.com
version 32
__lua__
-- math v1.2 jihem jmq 2021
-- picoscope101.fr cc by-sa
g={
	new=function(_,o)
		o=o or {}
		_.__index=_
		return setmetatable(o,_)
	end,
	centre=function(_,p)
		_.p_central=m:clone(p!=nil and p or _.m_central)
		return _
	end,
	deplace=function(_,p)
		_.p_central[1]+=p[1]
		_.p_central[2]+=p[2]
		_.m_central[1]+=p[1]
		_.m_central[2]+=p[2]
		for i=1,#_.points do   
			_.points[i][1]+=p[1]
			_.points[i][2]+=p[2]
		end
		return _
	end,
	symaxb=function(_,s)
		local i,x,y,a,b,c,d,ax,ay
		c=s[1]
		d=s[2]
		a=_.p_central[1]
		b=_.p_central[2]
		ax=(a+c*(b-d))/(1+c*c)
		ay=c*ax+d
		_.p_central[1]=2*ax-a
		_.p_central[2]=2*ay-b
		for i=1,#_.points do
			a=_.points[i][1]
			b=_.points[i][2]
			ax=(a+c*(b-d))/(1+c*c)
			ay=c*ax+d
			_.points[i][1]=2*ax-a
			_.points[i][2]=2*ay-b
		end
		return _
	end,
	symayb=function(_,s)
		local i,x,y,a,b,c,d,ax,ay
		c=s[1]
		d=s[2]
		a=_.p_central[1]
		b=_.p_central[2]
		ay=(b+c*(a-d))/(1+c*c)
		ax=c*ay+d
		_.p_central[1]=2*ax-a
		_.p_central[2]=2*ay-b
		for i=1,#_.points do
			a=_.points[i][1]
			b=_.points[i][2]
			ay=(b+c*(a-d))/(1+c*c)
			ax=c*ay+d
			_.points[i][1]=2*ax-a
			_.points[i][2]=2*ay-b
		end
		return _
	end,
	tourne=function(_,a)
		local i,x,y,ca,sa
		_.a+=a
		ca=m:cos(a)
		sa=m:sin(a)
		for i=1,#_.points do   
			_.points[i][1]-=_.p_central[1]
			_.points[i][2]-=_.p_central[2]
			x=(_.points[i][1]*ca-_.points[i][2]*sa)
			y=(_.points[i][1]*sa+_.points[i][2]*ca)
			_.points[i][1]=x+_.p_central[1]
			_.points[i][2]=y+_.p_central[2]
		end
		_.m_central[1]-=_.p_central[1]
		_.m_central[2]-=_.p_central[2]
		x=(_.m_central[1]*ca-_.m_central[2]*sa)
		y=(_.m_central[1]*sa+_.m_central[2]*ca)
		_.m_central[1]=x+_.p_central[1]
		_.m_central[2]=y+_.p_central[2]
		return _
	end,
	trace=function(_,c)
		local i
		if #_==2 then
			if type(_[1])=='number' then
				m:pset(_,c)
			else
				m:line(_[1],_[2],c)
			end
		else 
			for i=1,#_.segments do
				m:segment(
					_.points[_.segments[i][1]],
					_.points[_.segments[i][2]]   
				):trace(c)
			end
		end
		return _
	end,
	zoome=function(_,x)
		local i
		for i=1,#_.points do   
			_.points[i][1]=x*(_.points[i][1]-_.p_central[1])+_.p_central[1]
			_.points[i][2]=x*(_.points[i][2]-_.p_central[2])+_.p_central[2]
		end
		_.m_central[1]=x*(_.m_central[1]-_.p_central[1])+_.p_central[1]
		_.m_central[2]=x*(_.m_central[2]-_.p_central[2])+_.p_central[2]
		return _
	end
}

m={
	a=360,
	abs=function(_,x)return abs(x) end,
	atan2=function(_,x,y) return m.a*(1-atan2(x,y))end,
	band=function(_,x,y)return band(x,y)end,
	bnot=function(_,x)return bnot(x)end,
	bor=function(_,x,y)return bor(x,y)end,
	bxor=function(_,x,y)return bxor(x,y)end,
	camera=function(_,p)camera(p[1],-p[2])end,
	clone=function(_,o, e)if type(o) ~= 'table' then return o end if e and e[o] then return e[o] end local s = e or {}local r = {}s[o] = r for k, v in pairs(o) do r[m:clone(k, s)] = m:clone(v, s) end return setmetatable(r, getmetatable(o))end,
	cos=function(_,a)return cos(a/m.a)end,
	figure=function(_,o)o.p_central=o.p_central or m:point(0,0) o.a=o.a or 0 o.m_central=m:clone(o.p_central) return g:new(o)end,
	flr=function(_,x)return flr(x)end,
	line=function(_,p1,p2,c)p1=m.t(p1)p2=m.t(p2)line(p1[1],p1[2],p2[1],p2[2],c)end,
	max=function(_,x,y)return max(x,y)end,
	mid=function(_,x,y,z)return mid(x,y,z)end,
	min=function(_,x,y)return min(x,y)end,
	pget=function(_,p)p=m.t(p)return pget(p[1],p[2])end,
	point=function(_,x,y)return g:new({x,y})end,
	pset=function(_,p,c)p=m.t(p)pset(p[1],p[2],c)end,
	rnd=function(_,x)return rnd(x)end,
	segment=function(_,p1,p2)return g:new({p1,p2})end,
	shl=function(_,x,y)return shl(x,y)end,
	shr=function(_,x,y)return shr(x,y)end,
	sgn=function(_,x) return x!=0 and sgn(x) or 0 end,
	sin=function(_,a) return -sin(a/m.a)end,
	sqrt=function(_,x)return sqrt(x)end,
	srand=function(_,x)return srand(x)end,
	t=function(p)return{63+p[1],64-p[2]}end,
}